package ztl.ui;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.List;

import ztl.model.RestrictedArea;
import ztl.model.Ticket;
import ztl.model.Transit;
import ztl.persistence.MalformedFileException;
import ztl.persistence.MyTransitReader;
import ztl.persistence.TransitReader;

public class MyController implements Controller
{
	private RestrictedArea restrictedArea;
	private List<Transit> transits;
	private double totalAmount;
	
	public MyController(RestrictedArea restrictedArea) throws IOException, MalformedFileException
	{
		this.restrictedArea = restrictedArea;
		this.totalAmount = 0;
		
		TransitReader transitReader = new MyTransitReader();
		Reader reader = new FileReader("transiti.txt");
		this.transits = transitReader.read(reader);
		reader.close();
	}
		
	@Override
	public Iterable<Transit> getAllTransits()
	{
		return transits;
	}

	@Override
	public Ticket manageTransit(Transit transit)
	{
		Ticket ticket = restrictedArea.manageTransit(transit);
		if (ticket != null)
		{
			totalAmount += ticket.getCost();
		}
		return ticket;
	}
	
	@Override
	public double getTotalAmount()
	{
		return totalAmount;
	}
}
